//=================================================================================
function _nop(a,b,c,d,e,f,g,h)
{
	// Do nothing
	return null;
}
function _true(a,b,c,d,e,f,g,h)
{
	return true;
}
function _false(a,b,c,d,e,f,g,h)
{
	return false;
}
function _nop(a,b,c,d,e,f,g,h)
{
	return {};
}
function _false(a,b,c,d,e,f,g,h)
{
	return false;
}
function _isDev(a,b,c,d,e,f)
{
	return window.developer_mode;
}

var dbg_LocalSettings = {};
function dbg_getLocalSetting(name)
{
	return dbg_LocalSettings[name];
}
function dbg_setLocalSetting(name,value)
{
	dbg_LocalSettings[name] = value;
}
function dbg_OpenUrl(url)
{
	window.open(url);
}
//=================================================================================
function getWidgetIfaceDbgWin()
{
	var iface = {
		id: "IfaceDbg"
		,isDebug: _true
		,isDocked: _false
		,isDeveloper: _isDev
		,getLocalSetting: dbg_getLocalSetting
		,setLocalSetting: dbg_setLocalSetting
		,startupWidget: win_DoStartup
		,startupOptions: _nop
		,applyOptions: _nop
		,applyWidgetVisual: win_applyWidgetVisual
		,restartWidget: win_reloadGadget
		,openUrl: dbg_OpenUrl
		,getHostOverloads: _nop
	};
	return iface;
}
function getWidgetIfaceWin()
{
	var iface = {
		id: "IfaceWin"
		,isDebug: _false
		,isDocked: win_isDocked
		,isDeveloper: _isDev
		,getLocalSetting: win_getLocalSetting
		,setLocalSetting: win_setLocalSetting
		,startupWidget: win_DoStartup
		,startupOptions: win_DoStartupOptions
		,applyOptions: win_FinalizeOptions
		,applyWidgetVisual: win_applyWidgetVisual
		,restartWidget: win_reloadGadget
		,openUrl: win_OpenUrl
		,getHostOverloads: _nop
	};
	return iface;
}
function getWidgetIfaceDbgMac()
{
	var iface = {
		id: "IfaceMac"
		,isDebug: _true
		,isDocked: _false
		,isDeveloper: _isDev
		,getLocalSetting: dbg_getLocalSetting
		,setLocalSetting: dbg_setLocalSetting
		,startupWidget: mac_DoStartup
		,startupOptions: _nop
		,applyOptions: _nop
		,applyWidgetVisual: mac_applyWidgetVisual
		,restartWidget: mac_reloadGadget
		,openUrl: dbg_OpenUrl
		,getHostOverloads: _nop
	};
	return iface;
}
function getWidgetIfaceMac()
{
	var iface = {
		id: "IfaceMac"
		,isDebug: _false
		,isDocked: _false
		,isDeveloper: _isDev
		,getLocalSetting: mac_getLocalSetting
		,setLocalSetting: mac_setLocalSetting
		,startupWidget: mac_DoStartup
		,startupOptions: _nop
		,applyOptions: _nop
		,applyWidgetVisual: mac_applyWidgetVisual
		,restartWidget: mac_reloadGadget
		,openUrl: mac_OpenUrl
		,getHostOverloads: mac_getHostOverloads
	};
	return iface;
}
//=================================================================================
function dump(arr,level) {
	var dumped_text = "";
	if(!level){
		level = 0;
	}
	if(level>10){
		return "error, too deep";
	}
	
	//The padding given at the beginning of the line.
	var level_padding = "";
	for(var j=0;j<level+1;j++) level_padding += "    ";
	
	if(typeof(arr) == 'object') { //Array/Hashes/Objects 
		for(var item in arr) {
			var value = arr[item];
			
			if(typeof(value) == 'object') { //If it is an array,
				dumped_text += level_padding + "'" + item + "' ...\n";
				dumped_text += dump(value,level+1);
			} else {
				dumped_text += level_padding + "'" + item + "' => \"" + value + "\"\n";
			}
		}
	} else { //Stings/Chars/Numbers etc.
		dumped_text = "===>"+arr+"<===("+typeof(arr)+")";
	}
	return dumped_text;
}

function padStr(number, length, with_str) {
	if(!with_str){
		with_str = " ";
	}
    var str = '' + number;
    while (str.length < length) {
        str = with_str + str;
    }
    return str;
}

function escapeHtml(html) {
  return html.
    replace(/&/gmi, '&amp;').
    replace(/"/gmi, '&quot;').
    replace(/>/gmi, '&gt;').
    replace(/</gmi, '&lt;')
}

function coalesce(obj, def_val) {
	if(typeof(obj) === 'undefined' || obj == null){
		return def_val;
	}
	return obj;
}

function coalesceIfNan(num,def){
	if(!def){
		def = 0;
	}
	if(!num || isNaN(num)){
		return def;
	}
	return num;
}

function clamp(val,minv,maxv) {
	if(val<minv){
		return minv;
	}
	if(val>maxv){
		return maxv;
	}
	return val;
}
//=================================================================================
function delayCall(delay_ms, delayedfunc, param)
{
	//xlog("Setting timeout on "+delay_ms+"ms at " + printStackTrace());
	var timeoutmethod = function(){
		//xlog("Timeout triggered!");
		delayedfunc.apply(this,[param]);
	};
	setTimeout(timeoutmethod, delay_ms);
}

function interpolate(needle,from,to)
{
	return from+(to-from)*needle;
}
//=================================================================================
function moveDate2EndOfDay(dt)
{
	dt.setHours(23,59,59);
	return dt;
}
function getDateDiff(fdate,endate)
{
	var diff = (fdate.getTime()/1000-endate.getTime()/1000)/_day_in_sec;
	//alert( "fdate="+fdate+"; endate="+endate+"; kdd="+(fdate.getTime()/1000-endate.getTime()/1000)+"; dis="+_day_in_sec+"; dive="+diff+"; pint=" +parseInt(diff)  );
	return parseInt(diff);
}

function getDateAdvanced(fdate,days2add)
{
	if(!fdate){
		fdate = new Date();
	}
	return new Date(fdate.getTime()+days2add*_day_in_sec*1000);
}
//=================================================================================
// from http://github.com/emwendelin/javascript-stacktrace/raw/master/stacktrace.js
/**
 * Main function giving a function stack trace with a forced or passed in Error 
 *
 * @cfg {Error} e The error to create a stacktrace from (optional)
 * @cfg {Boolean} guess If we should try to resolve the names of anonymous functions
 * @return {Array} of Strings with functions, lines, files, and arguments where possible 
 */
function printStackTrace(options) {
    var ex = (options && options.e) ? options.e : null;
    var guess = options ? !!options.guess : true;
    
    var p = new printStackTrace.implementation();
    var result = p.run(ex);
    return (guess) ? p.guessFunctions(result) : result;
}
printStackTrace.implementation = function() {};
printStackTrace.implementation.prototype = {
    run: function(ex) {
        // Use either the stored mode, or resolve it
        var mode = this._mode || this.mode();
        if (mode === 'other') {
            return this.other(arguments.callee);
        } else {
            ex = ex ||
                (function() {
                    try {
                        (0)();
                    } catch (e) {
                        return e;
                    }
                })();
            return this[mode](ex);
        }
    },
    
	/**
	 * @return {String} mode of operation for the environment in question.
	 */
    mode: function() {
        try {
            (0)();
        } catch (e) {
            if (e.arguments) {
                return (this._mode = 'chrome');
            } else if (window.opera && e.stacktrace) {
				return (this._mode = 'opera10');
			} else if (e.stack) {
                return (this._mode = 'firefox');
            } else if (window.opera && !('stacktrace' in e)) { //Opera 9-
                return (this._mode = 'opera');
            }
        }
        return (this._mode = 'other');
    },

	/**
	 * Given a context, function name, and callback function, overwrite it so that it calls
	 * printStackTrace() first with a callback and then runs the rest of the body.
	 * 
	 * @param {Object} context of execution (e.g. window)
	 * @param {String} functionName to instrument
	 * @param {Function} function to call with a stack trace on invocation
	 */
	instrumentFunction: function(context, functionName, callback) {
		context = context || window;
		context['_old' + functionName] = context[functionName];
		context[functionName] = function() { 
			callback.call(this, printStackTrace());
			return context['_old' + functionName].apply(this, arguments);
		}
		context[functionName]._instrumented = true;
	},
	
	/**
	 * Given a context and function name of a function that has been
	 * instrumented, revert the function to it's original (non-instrumented)
	 * state.
	 *
	 * @param {Object} context of execution (e.g. window)
	 * @param {String} functionName to de-instrument
	 */
	deinstrumentFunction: function(context, functionName) {
		if (context[functionName].constructor === Function
				&& context[functionName]._instrumented
				&& context['_old' + functionName].constructor === Function) {
			context[functionName] = context['_old' + functionName];
		}
	},
    
	/**
	 * Given an Error object, return a formatted Array based on Chrome's stack string.
	 * 
	 * @param e - Error object to inspect
	 * @return Array<String> of function calls, files and line numbers
	 */
    chrome: function(e) {
        return e.stack.replace(/^.*?\n/, '').
                replace(/^.*?\n/, '').
                replace(/^.*?\n/, '').
                replace(/^[^\(]+?[\n$]/gm, '').
                replace(/^\s+at\s+/gm, '').
                replace(/^Object.<anonymous>\s*\(/gm, '{anonymous}()@').
                split('\n');
    },

	/**
	 * Given an Error object, return a formatted Array based on Firefox's stack string.
	 * 
	 * @param e - Error object to inspect
	 * @return Array<String> of function calls, files and line numbers
	 */
    firefox: function(e) {
        return e.stack.replace(/^.*?\n/, '').
                replace(/(?:\n@:0)?\s+$/m, '').
                replace(/^\(/gm, '{anonymous}(').
                split('\n');
    },

	/**
	 * Given an Error object, return a formatted Array based on Opera 10's stacktrace string.
	 * 
	 * @param e - Error object to inspect
	 * @return Array<String> of function calls, files and line numbers
	 */
	opera10: function(e) {
		var stack = e.stacktrace;
		var lines = stack.split('\n'), ANON = '{anonymous}',
			lineRE = /.*?line (\d+), column (\d+) in ((<anonymous function\:?\s*(\S+))|([^\(]+)\([^\)]*\))(?: in )?(.*)\s*$/i, i, j, len;
		for (i = 2, j = 0, len = lines.length; i < len - 2; i++) {
	        if (lineRE.test(lines[i])) {
				var location = RegExp.$6 + ':' + RegExp.$1 + ':' + RegExp.$2;
				var fnName = RegExp.$3;
				fnName = fnName.replace(/<anonymous function\s?(\S+)?>/g, ANON);
				lines[j++] = fnName + '@' + location;
	        }
		}
        
        lines.splice(j, lines.length - j);
        return lines;
	},
    
    // Opera 7.x-9.x only!
    opera: function(e) {
        var lines = e.message.split('\n'), ANON = '{anonymous}', 
            lineRE = /Line\s+(\d+).*?script\s+(http\S+)(?:.*?in\s+function\s+(\S+))?/i, 
			i, j, len;
        
        for (i = 4, j = 0, len = lines.length; i < len; i += 2) {
			//TODO: RegExp.exec() would probably be cleaner here
            if (lineRE.test(lines[i])) {
                lines[j++] = (RegExp.$3 ? RegExp.$3 + '()@' + RegExp.$2 + RegExp.$1 : ANON + '()@' + RegExp.$2 + ':' + RegExp.$1) + ' -- ' + lines[i + 1].replace(/^\s+/, '');
            }
        }
        
        lines.splice(j, lines.length - j);
        return lines;
    },
    
    // Safari, IE, and others
    other: function(curr) {
        var ANON = '{anonymous}', fnRE = /function\s*([\w\-$]+)?\s*\(/i,
	 		stack = [], j = 0, fn, args;
        
        var maxStackSize = 10;
        while (curr && stack.length < maxStackSize) {
            fn = fnRE.test(curr.toString()) ? RegExp.$1 || ANON : ANON;
            args = Array.prototype.slice.call(curr['arguments']);
            stack[j++] = fn + '(' + this.stringifyArguments(args) + ')';
            curr = curr.caller;
        }
        return stack;
    },
    
    /**
     * Given arguments array as a String, subsituting type names for non-string types.
     *
     * @param {Arguments} object
     * @return {Array} of Strings with stringified arguments
     */
    stringifyArguments: function(args) {
        for (var i = 0; i < args.length; ++i) {
            var arg = args[i];
            if (arg === undefined) {
                args[i] = 'undefined';
            } else if (arg === null) {
                args[i] = 'null';
            } else if (arg.constructor) {
                if (arg.constructor === Array) {
                    if (arg.length < 3) {
                        args[i] = '[' + this.stringifyArguments(arg) + ']';
                    } else {
                        args[i] = '[' + this.stringifyArguments(Array.prototype.slice.call(arg, 0, 1)) + '...' + this.stringifyArguments(Array.prototype.slice.call(arg, -1)) + ']';
                    }
                } else if (arg.constructor === Object) {
                    args[i] = '#object';
                } else if (arg.constructor === Function) {
                    args[i] = '#function';
                } else if (arg.constructor === String) {
                    args[i] = '"' + arg + '"';
                }
            }
        }
        return args.join(',');
    },
    
    sourceCache: {},
    
    /**
     * @return the text from a given URL.
     */
    ajax: function(url) {
        var req = this.createXMLHTTPObject();
        if (!req) {
            return;
        }
        req.open('GET', url, false);
        req.setRequestHeader('User-Agent', 'XMLHTTP/1.0');
        req.send('');
        return req.responseText;
    },
    
	/**
	 * Try XHR methods in order and store XHR factory.
	 *
	 * @return <Function> XHR function or equivalent
	 */
    createXMLHTTPObject: function() {
        var xmlhttp, XMLHttpFactories = [
            function() {
                return new XMLHttpRequest();
            }, function() {
                return new ActiveXObject('Msxml2.XMLHTTP');
            }, function() {
                return new ActiveXObject('Msxml3.XMLHTTP');
            }, function() {
                return new ActiveXObject('Microsoft.XMLHTTP');
            }
        ];
        for (var i = 0; i < XMLHttpFactories.length; i++) {
            try {
                xmlhttp = XMLHttpFactories[i]();
                // Use memoization to cache the factory
                this.createXMLHTTPObject = XMLHttpFactories[i];
                return xmlhttp;
            } catch (e) {}
        }
    },

	/**
	 * Given a URL, check if it is in the same domain (so we can get the source
	 * via Ajax).
	 *
	 * @param url <String> source url
	 * @return False if we need a cross-domain request
	 */
	isSameDomain: function(url) {
		return url.indexOf(location.hostname) !== -1;
	},
    
	/**
	 * Get source code from given URL if in the same domain.
	 *
	 * @param url <String> JS source URL
	 * @return <String> Source code
	 */
    getSource: function(url) {
        if (!(url in this.sourceCache)) {
            this.sourceCache[url] = this.ajax(url).split('\n');
        }
        return this.sourceCache[url];
    },
    
    guessFunctions: function(stack) {
        for (var i = 0; i < stack.length; ++i) {
            var reStack = /{anonymous}\(.*\)@(\w+:\/\/([-\w\.]+)+(:\d+)?[^:]+):(\d+):?(\d+)?/;
            var frame = stack[i], m = reStack.exec(frame);
            if (m) {
                var file = m[1], lineno = m[4]; //m[7] is character position in Chrome
                if (file && this.isSameDomain(file) && lineno) {
                    var functionName = this.guessFunctionName(file, lineno);
                    stack[i] = frame.replace('{anonymous}', functionName);
                }
            }
        }
        return stack;
    },
    
    guessFunctionName: function(url, lineNo) {
        try {
            return this.guessFunctionNameFromLines(lineNo, this.getSource(url));
        } catch (e) {
            return 'getSource failed with url: ' + url + ', exception: ' + e.toString();
        }
    },
    
    guessFunctionNameFromLines: function(lineNo, source) {
        var reFunctionArgNames = /function ([^(]*)\(([^)]*)\)/;
        var reGuessFunction = /['"]?([0-9A-Za-z_]+)['"]?\s*[:=]\s*(function|eval|new Function)/;
        // Walk backwards from the first line in the function until we find the line which
        // matches the pattern above, which is the function definition
        var line = "", maxLines = 10;
        for (var i = 0; i < maxLines; ++i) {
            line = source[lineNo - i] + line;
            if (line !== undefined) {
                var m = reGuessFunction.exec(line);
                if (m && m[1]) {
                    return m[1];
                } else {
                    m = reFunctionArgNames.exec(line);
                    if (m && m[1]) {
                        return m[1];
                    }
                }
            }
        }
        return '(?)';
    }
};
//============================================================================================