/* utilities */
function getJsDate2ServerDate(dt)
{
	var dt_str = padStr(dt.getUTCFullYear(),4,"0")+"-"+padStr(dt.getUTCMonth()+1,2,"0")+"-"+padStr(dt.getUTCDate(),2,"0");
	return dt_str;
}

function getServerDate2JsDate(date_str)
{
	var date_pars = date_str.split("-");//year-month-day
	var tmoffset_sec = _daynow.getTimezoneOffset()*60;
	var date_obj = new Date(Date.UTC(date_pars[0],date_pars[1]-1,date_pars[2],0,0,0) - 1000*tmoffset_sec);
	//xlog("getServerDate2JsDate date_str="+date_str+"; getTimezoneOffset="+_daynow.getTimezoneOffset()+"; _daynow="+_daynow+"; date_obj="+date_obj);
	//alert("date_str="+date_str+"; date_obj="+date_obj+" y="+date_pars[0]+" m="+date_pars[1]+" d="+date_pars[2]);
	return date_obj;
}

function getDrinkKey(drink_id,data)
{
	return "d"+drink_id;
}

var spancodes = {};
function getTsSec()
{
	return parseInt((new Date()).getTime()/1000);
}
function setSpanStartSec(spancod, dt_secs)
{
	spancodes[spancod] = dt_secs;
}
function isSpanElapsedSec(spancod, secs, defval)
{
	var dt = getTsSec();
	var dt_next = dt+secs;
	if(!spancodes[spancod]){
		setSpanStartSec(spancod, dt_next);
		return (defval?true:false);
	}
	if(spancodes[spancod] < dt){
		setSpanStartSec(spancod, dt_next);
		return true;
	}
	return false;
}

function getPureAlcoholEquivalent(amount, strength)
{
	return (strength / 100) * amount;
}

function getGradientColor(amount, strength, black_point, white_mixer) {
	//black_point is the volume of pure spirit where black zone starts
	//returns the color value from green (0) through yellow, red to black
	var x = getPureAlcoholEquivalent(amount, strength) / black_point;
	if(!white_mixer){
		white_mixer = 0;
	}

	//we use a sectionaly-continuous function
	var r = 0;
	var g = 0;
	var b = 0;
	if (x >= 0 && x < 1/5) //green to yellow
	{
		r = x*4*255;
		g = 200;
	} else if (x >= 1/5 && x < 1/3) //yellow
	{
		r = Math.min(255, x*4*255);
		g = 200 - (x-1/5)*0.5*200;
	} else if (x >= 1/3 && x < 3/4) //orange to red
	{
		r = 255;
		g = 180 - (x-1/3) * 2*180;
	} else if (x >= 3/4 && x < 1) { //fade to black
		r = 255 - (x-3/4) * 3*255;
		g = 30;
	} else { //>1
		r = 0;
		g = 0;
	}
	r = interpolate(white_mixer,r,255);
	g = interpolate(white_mixer,g,255);
	b = interpolate(white_mixer,b,255);
	//convert to hex
	var rr = Math.round(r);
	var gg = Math.round(g);
	var bb = Math.round(b);
	rr = rr.toString(16);
	gg = gg.toString(16);
	bb = bb.toString(16);
	if (rr.length == 1) rr = '0' + rr;
	if (gg.length == 1) gg = '0' + gg;
	if (bb.length == 1) bb = '0' + bb;

	return '#' + rr + gg + bb;
}

function placeDivOverDiv(div_what, div_to, xoff, yoff, woff, hoff) {
	var dd_div_to = $(div_to);
	var dd_div_wh = $(div_what);
	var pos = dd_div_to.offset();
	var ww = dd_div_to.width();
	var hh = dd_div_to.height();
	pos.left = coalesceIfNan(pos.left);// Safari paranija...
	pos.top = coalesceIfNan(pos.top);// Safari paranija...
	if(xoff != null){
		dd_div_wh.css('left', pos.left + xoff);
	}
	if(yoff != null){
		dd_div_wh.css('top', pos.top + yoff);
	}
	if(woff != null){
		dd_div_wh.css('width', ww + woff);
	}
	if(hoff != null){
		dd_div_wh.css('height', hh + hoff);
	}
}

function setDivPos(div_what, xoff, yoff) {
	if(xoff != null){
		$(div_what).css('left', xoff);
	}
	if(yoff != null){
		$(div_what).css('top', yoff);
	}
}

function setDivSize(div_what, woff, hoff) {
	var theDiv = $(div_what);
	if(woff != null){
		var wpad = parseInt(theDiv.css("padding-right"), 10) + parseInt(theDiv.css("padding-left"), 10);
		theDiv.css('width', woff - wpad);
	}
	if(hoff != null){
		var hpad = parseInt(theDiv.css("padding-bottom"), 10) + parseInt(theDiv.css("padding-top"), 10);
		theDiv.css('height', hoff - hpad);
	}
}

function replaceTranslations() {
	$("span[i18n]").each(function(){ 
		var contn = $(this).html();
		$(this).html($._b(contn));
	});
}

function replaceLinks(from_link,to_link) {
	$("a[href^='"+from_link+"']").each(function(){ 
		this.href = to_link;
	});
}

function addInputSmartclick(div_id,toggler) {
	var div_var = $(div_id);
	div_var.click(function(event){
		var evtarg = $(event.target);
		try{
			if(!evtarg.is("input")){
				var inp = $(this).find('input');
				if(toggler < 0){
					inp.attr('checked',!inp.attr('checked'));
				}else{
					inp.attr('checked',toggler>0?true:false);
				}
			}
		}catch(e){xlog("error "+e.message+"; stack="+printStackTrace({e:e}));}
	});
}

function addInputSmartclickX(click_id,target_id,toggler) {
	var div_var = $(click_id);
	div_var.click(function(event){
		var evtarg = $(event.target);
		try{
			var inp = $(target_id);
			if(toggler < 0){
				inp.attr('checked',!inp.attr('checked'));
			}else{
				inp.attr('checked',toggler>0?true:false);
			}
		}catch(e){xlog("error "+e.message+"; stack="+printStackTrace({e:e}));}
	});
}

var recur_prevent = 0;
var xlog_llist = "";
function xlog(msg){
	if(recur_prevent == 0){
		recur_prevent = 1;
		// not saving log anymore... error on reading!
		xlog_llist= msg+"\n- "+xlog_llist;
		if(xlog_llist.length>3000){
			xlog_llist = xlog_llist.slice(0,3000);
		}
		recur_prevent = 0;
	}
	if(window.$){
		$.log(msg);
	}
}
function xlog_get(){
	//var llist = _sys.getLocalSetting("_dbglist");
	return "LOG:\n---\n"+xlog_llist+"\n---\n";
}
function xlog_show(at_node){
	$(at_node).append('<textarea style="position:absolute;left:0px;top:0px;border: 1px solid black;background: white;width:98%; height: 98%;overflow:hidden;">'+xlog_get()+'</textarea>');
}
function constructSeqTracker(seq,callback){
	var newSeqTracker = {};
	var track_what = seq;
	var track_ok = callback;
	var track_index = 0;
	var track_lastptime = 0;
	newSeqTracker.onKeyup = function (e) {
		var noewtime = (new Date()).getTime();
		if(track_index >= track_what.length){
			track_index = 0;
		}
		if(noewtime - track_lastptime > 10*1000){
			track_index = 0;
			track_lastptime = noewtime;
		}
		if (e.keyCode == track_what.charCodeAt(track_index)) {
			track_lastptime = noewtime;
			track_index++;
			if(track_index >= track_what.length){
				track_index = 0;
				callback.apply();
			}
		}
	};
	return newSeqTracker;
}